function Create(self)
	self.LifeTime = Timer()
	self.oldDist = math.huge
	
	if self.Sharpness > -1 then
		self.Target = MovableMan:GetMOFromID(self.Sharpness)
	end
end

function Update(self)
	if self.LifeTime:IsPastSimMS(2000) then
		self:GibThis()
	elseif self.Target then
		if MovableMan:ValidMO(self.Target) and self.Target.PresetName ~= "Entity" then
			if SceneMan:CastStrengthSumRay(self.Pos + self.Vel, self.Target.Pos, 128, 9) < 20 then
				local Delta = SceneMan:ShortestDistance(self.Pos, self.Target.Pos + self.Target.Vel*5, false)
				local dist = Delta.Magnitude
				if dist > self.oldDist and dist < self.Target.Diameter * 0.5 + 50 then
					self:GibThis()
				else
					local RelVel = self:UnRotateOffset(self.Vel)
					if RelVel.X > 10 then	-- Air resistance for movement forward
						RelVel.X = RelVel.X * 0.985
					end
					
					if RelVel.Y > 7 then	-- Air resistance for movement Perpendicular to RotAngle
						RelVel.Y = RelVel.Y * 0.93		-- 7%
					else
						RelVel.Y = RelVel.Y * 0.995		-- 0.5%
					end
					
					self.Vel = self:RotateOffset(RelVel) + Delta:Normalize()			-- Move towards the target
					self.RotAngle = self.RotAngle*0.2 + self.Vel.AbsRadAngle*0.8	-- Fake OrientToVel
				end
				
				self.oldDist = dist
			else
				self.Vel = self.Vel + Vector(0.4,0):RadRotate(self.RotAngle)	-- Fake PushesEmitter
				self.RotAngle = self.RotAngle*0.7 + self.Vel.AbsRadAngle*0.3	-- Fake OrientToVel				
			end
		else
			self:GibThis()
		end
	else
		self.Vel = self.Vel + Vector(0.4,0):RadRotate(self.RotAngle)	-- Fake PushesEmitter
		self.RotAngle = self.RotAngle*0.7 + self.Vel.AbsRadAngle*0.3	-- Fake OrientToVel
	end

	self.Vel = self.Vel + Vector(0,0.2)	-- Fake gravity
end