function Gauntlet:StartActivity()
	collectgarbage("collect")
	
	-- Enemy
	self.Enemy = {}
	self.Enemy.HeavyWpn = {{"Assault Rifle", "Independent.rte"}, {"AK-47", "Base.rte"}, {"Laser Rifle", "Base.rte"}, {"SMG", "Base.rte"}, {"Flak Cannon", "Base.rte"}}
	self.Enemy.LightWpn = {{"Pistol", "Base.rte"}, {"Pistol", "Base.rte"}, {"Pistol", "Base.rte"}, {"Blaster Pistol", "Base.rte"}, {"Blaster Pistol", "Base.rte"}, {"Shotgun", "Base.rte"}}
	self.Enemy.Tools = {{"Light Digger", "Base.rte"}}
	self.Enemy.Grenades = {{"Blue Bomb", "Base.rte"}}

	-- Player
	self.Player = {}
	self.Player.HeavyWpn = {{"AK-47", "Base.rte"}, {"AK-47", "Base.rte"}, {"Flak Cannon", "Base.rte"}}
	self.Player.LightWpn = {{"Pistol", "Base.rte"}, {"Pistol", "Base.rte"}, {"Blaster Pistol", "Base.rte"}, {"Shotgun", "Base.rte"}, {"SMG", "Base.rte"}}
	self.Player.Grenades = {{"Frag Grenade", "Base.rte"}}


	self.SpawnTimer = Timer()
	self.spawnDelay = 0
	self.IndependentTimer = Timer()
	self.GarbageTimer = Timer()
	self.LZs = {SceneMan.Scene:GetArea("LZLeft"), SceneMan.Scene:GetArea("LZRight")}
	
	
	if self.Difficulty <= GameActivity.CAKEDIFFICULTY then
		self:SetTeamFunds(3000, Activity.TEAM_1)
		self.independentDelay = RangeRand(50000, 70000)
		self.newDelay = {min=50000, max=100000}
	elseif self.Difficulty <= GameActivity.EASYDIFFICULTY then
		self:SetTeamFunds(1500, Activity.TEAM_1)
		self.independentDelay = RangeRand(40000, 50000)
		self.newDelay = {min=40000, max=80000}
	elseif self.Difficulty <= GameActivity.MEDIUMDIFFICULTY then
		self:SetTeamFunds(1000, Activity.TEAM_1)
		self.independentDelay = RangeRand(35000, 45000)
		self.newDelay = {min=35000, max=70000}
	elseif self.Difficulty <= GameActivity.HARDDIFFICULTY then
		self:SetTeamFunds(700, Activity.TEAM_1)
		self.independentDelay = RangeRand(30000, 40000)
		self.newDelay = {min=30000, max=60000}
	elseif self.Difficulty <= GameActivity.NUTSDIFFICULTY then
		self:SetTeamFunds(400, Activity.TEAM_1)
		self.independentDelay = RangeRand(20000, 30000)
		self.newDelay = {min=35000, max=50000}
	else
		self:SetTeamFunds(0, Activity.TEAM_1)
		self.independentDelay = 0
		self.newDelay = {min=5000, max=10000}
	end
	
	-- Initialize enemy actors
	if FrameMan.ResX < 680 then
		self.EnemyActor = "Enemy Robot 640"
		self.PlayerActor = "Player Robot 640"
	elseif FrameMan.ResX < 760 then
		self.EnemyActor = "Enemy Robot 720"
		self.PlayerActor = "Player Robot 720"
	elseif FrameMan.ResX < 850 then
		self.EnemyActor = "Enemy Robot 800"
		self.PlayerActor = "Player Robot 800"
	elseif FrameMan.ResX < 962 then
		self.EnemyActor = "Enemy Robot 900"
		self.PlayerActor = "Player Robot 900"
	elseif FrameMan.ResX < 1088 then
		self.EnemyActor = "Enemy Robot 1024"
		self.PlayerActor = "Player Robot 1024"
	elseif FrameMan.ResX < 1216 then
		self.EnemyActor = "Enemy Robot 1152"
		self.PlayerActor = "Player Robot 1152"
	elseif FrameMan.ResX < 1360 then
		self.EnemyActor = "Enemy Robot 1280"
		self.PlayerActor = "Player Robot 1280"
	elseif FrameMan.ResX < 1545 then
		self.EnemyActor = "Enemy Robot 1440"
		self.PlayerActor = "Player Robot 1440"
	else
		self.EnemyActor = "Enemy Robot 1650"
		self.PlayerActor = "Player Robot 1650"
	end
	
	-- Add brain
	if not self:GetPlayerBrain(0) then
		local Brain = CreateActor("Brain Case", "Base.rte")
		if Brain then
			Brain.Pos = Vector(1884, 1280)
			MovableMan:AddActor(Brain)
			self:SetPlayerBrain(Brain, 0)
			self:SetObservationTarget(Brain.Pos, 0)
			self:SwitchToActor(Brain, 0, Activity.TEAM_1)
		end
	end
	
	for i = 1, 7 do
		Ar = SceneMan.Scene:GetArea("SentryR" .. i)
		if Ar then
			Act = self:CreatePlayerActor()
			if not Act then
				break
			end
			
			Act.Pos = Ar:GetCenterPoint()
			Act.HFlipped = false
			MovableMan:AddActor(Act)
		end
	end
	
	for i = 1, 5 do
		Ar = SceneMan.Scene:GetArea("SentryL" .. i)
		if Ar then
			Act = self:CreatePlayerActor()
			if not Act then
				break
			end
			
			Act.Pos = Ar:GetCenterPoint()
			Act.HFlipped = true
			MovableMan:AddActor(Act)
		end
	end
end

function Gauntlet:CreateEnemyActor(mode)
	local Act = CreateAHuman(self.EnemyActor, "Independent.rte")
	if Act then
		local Wpn = self.Enemy.HeavyWpn[math.random(#self.Enemy.HeavyWpn)]
		Act:AddInventoryItem(CreateHDFirearm(Wpn[1], Wpn[2]))
		if PosRand() > 0.3 then
			Wpn = self.Enemy.LightWpn[math.random(#self.Enemy.LightWpn)]
			Act:AddInventoryItem(CreateHDFirearm(Wpn[1], Wpn[2]))
		end
		
		if PosRand() > 0.7 then
			Wpn = self.Enemy.Grenades[math.random(#self.Enemy.Grenades)]
			Act:AddInventoryItem(CreateTDExplosive(Wpn[1], Wpn[2]))
			if PosRand() > 0.5 then
				Act:AddInventoryItem(CreateTDExplosive(Wpn[1], Wpn[2]))
			end
		end
		
		if PosRand() > 0.2 then
			Wpn = self.Enemy.Tools[math.random(#self.Enemy.Tools)]
			Act:AddInventoryItem(CreateHDFirearm(Wpn[1], Wpn[2]))
		end
		
		Act.Team = Activity.TEAM_2
		Act.AIMode = mode or Actor.AIMODE_BRAINHUNT
	end
	
	return Act
end

function Gauntlet:CreatePlayerActor(mode)
	local Act = CreateAHuman(self.PlayerActor, "Independent.rte")
	if Act then
		local Wpn = self.Player.HeavyWpn[math.random(#self.Player.HeavyWpn)]
		Act:AddInventoryItem(CreateHDFirearm(Wpn[1], Wpn[2]))
		
		Wpn = self.Player.LightWpn[math.random(#self.Player.LightWpn)]
		Act:AddInventoryItem(CreateHDFirearm(Wpn[1], Wpn[2]))
		
		if PosRand() > 0.5 then
			Wpn = self.Player.Grenades[math.random(#self.Player.Grenades)]
			Act:AddInventoryItem(CreateTDExplosive(Wpn[1], Wpn[2]))
			if PosRand() > 0.5 then
				Act:AddInventoryItem(CreateTDExplosive(Wpn[1], Wpn[2]))
			end
		end
		
		Act.Team = Activity.TEAM_1
		Act.AIMode = mode or Actor.AIMODE_SENTRY
	end
	
	return Act
end

function Gauntlet:UpdateActivity()
	if self:ActivityOver() then
		return
	else
		local Brain = self:GetPlayerBrain(0)
		if not MovableMan:IsActor(Brain) or Brain.ClassName == "Entity" then
			self.ActivityState = Activity.OVER
		end
	end
	
	if self.Indep then
		if not MovableMan:IsActor(self.Indep) or self.Indep.ClassName == "Entity" then
			self.Indep = nil
			self.IndependentTimer:Reset()
			self.independentDelay = RangeRand(self.newDelay.min, self.newDelay.max)
		end
	elseif self.IndependentTimer:IsPastSimMS(self.independentDelay) then
		local Free = Vector()
		if SceneMan:CastObstacleRay(Vector(RangeRand(2700,3970), 0), Vector(0,2000), Vector(), Free, -1, -1, 4) ~= 0 then
			self.Indep = CreateAHuman("Independent", "Independent.rte")
			if self.Indep then
				self.Indep.Pos = Free + Vector(0,-30)
				self.Indep.Team = Activity.TEAM_2
				self.Indep.AIMode = Actor.AIMODE_BRAINHUNT
				self.Indep.HFlipped = PosRand() > 0.5
				self.Indep:FlashWhite(500)
				MovableMan:AddActor(self.Indep)
			end
		end
	end
	
	if self.SpawnTimer:IsPastSimMS(self.spawnDelay) and MovableMan:GetMOIDCount() < 200 then
		self.SpawnTimer:Reset()
		self.spawnDelay = RangeRand(25000, 40000) - self.Difficulty*100
		
		local Act = CreateACDropShip("Drop Ship MK1", "Base.rte")
		if Act then
			Act.Vel = Vector(0, 20)
			Act.Pos = Vector(RangeRand(2600,3150), -75)
			Act.Team = Activity.TEAM_2
			Act.AIMode = Actor.AIMODE_DELIVER
			Act:AddInventoryItem(self:CreateEnemyActor())
			
			MovableMan:AddActor(Act)
		end
		
		if PosRand() < 0.4 then
			Act = CreateACDropShip("Drop Ship MK1", "Base.rte")
			if Act then
				Act.Vel = Vector(0, 20)
				Act.Pos = Vector(RangeRand(3250,3800), -75)
				Act.Team = Activity.TEAM_2
				Act.AIMode = Actor.AIMODE_DELIVER
				Act:AddInventoryItem(self:CreateEnemyActor())
				
				MovableMan:AddActor(Act)
			end
		elseif PosRand() < 0.3 then
			Act = CreateACDropShip("Drop Ship MK1", "Base.rte")
			if Act then
				Act.Pos = Vector(RangeRand(100,300), -75)
				Act.Team = Activity.TEAM_2
				Act.AIMode = Actor.AIMODE_DELIVER
				Act:AddInventoryItem(self:CreateEnemyActor())
				
				MovableMan:AddActor(Act)
			end
		end
	end
	
	if self.GarbageTimer:IsPastSimMS(500) then
		self.GarbageTimer:Reset()
		collectgarbage("step")
	end
end
